#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/
_rev = "$Revision: 39 $"[10:-1].strip()
__version__ = "1.1."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ =  "$Date: 2008-04-24 16:58:02 +0100 (Thu, 24 Apr 2008) $"[6:18].strip()

#Editor of connection profile

import pygtk
pygtk.require('2.0')
import gtk

def ErrorDialog(parent, title,msg):
    #display an error
    msgbox = gtk.MessageDialog(parent, buttons = gtk.BUTTONS_OK, flags = gtk.DIALOG_MODAL,
                                type= gtk.MESSAGE_ERROR, message_format = msg)
    msgbox.set_title(title)
    msgbox.run()
    msgbox.destroy()


def EditorDialog(window,prog,strings ):
    dialog = gtk.Dialog(title="%s - %s"%(strings["editor_title"],prog['profile']), parent = window,
                        flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                        buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))

    connection = prog['connection']
    name = gtk.Entry()
    name.set_max_length(25)
    name.set_width_chars(25)
    name.set_visibility(True)
    name.set_text(connection['name'])
    name.set_invisible_char('*')
    #name.set_property("editable", False)
    name.set_property("has-frame", False)
    name.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))

    apn = gtk.Entry()
    apn.set_max_length(25)
    apn.set_width_chars(25)
    apn.set_visibility(True)
    apn.set_text(connection['apn'])
    apn.set_invisible_char('*')
    apn.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))
 
    usr = gtk.Entry()
    usr.set_max_length(25)
    usr.set_width_chars(25)
    usr.set_visibility(True)
    usr.set_text(connection['username'])
    usr.set_invisible_char('*')
    usr.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))

    psswd = gtk.Entry()
    psswd.set_max_length(25)
    psswd.set_width_chars(25)
    psswd.set_visibility(False)
    psswd.set_text(connection['password'])
    psswd.set_invisible_char('*')
    psswd.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))

    
####
# Layout of connection edito in Table
####    
    hbox = gtk.Table(4,2)
    hbox.set_col_spacing(0, 3)
    hbox.set_col_spacing(1, 3)

    hbox.attach(gtk.Label(strings['editor_profile_name']), 0,1,0,1)
    hbox.attach(name, 1,2,0,1)

    hbox.attach(gtk.Label(strings["editor_apn"]), 0,1,1,2)
    hbox.attach(apn, 1,2,1,2)

    hbox.attach(gtk.Label(strings["editor_user"]), 0,1,2,3)
    hbox.attach(usr, 1,2,2,3)
 
    hbox.attach(gtk.Label(strings["editor_password"]), 0,1,3,4)
    hbox.attach(psswd, 1,2,3,4)

###
###
    dialog.vbox.pack_start(hbox)
    #dialog.vbox.pack_start(Hbox)
    dialog.show_all()
    response = dialog.run()
    dialog.hide()
    
    if response == gtk.RESPONSE_ACCEPT:
        connection['name'] = name.get_text()
        connection['apn'] = apn.get_text()
        connection['username']= usr.get_text()
        connection['password']= psswd.get_text()
        return connection
    else:
        return None

def runEditorDialog(window,prog,strings):
    ans = None
    while True:
        ans = EditorDialog(window,prog,strings)
        valid = True
        #Add some validation here
        if not valid: 
            ErrorDialog(window, strings['error'],strings['error_apnusrpsswd'])
            continue
        break
    return ans
    
