#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/
_rev = "$Revision: 39 $"[10:-1].strip()
__version__ = "1.1."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ =  "$Date: 2008-04-24 16:58:02 +0100 (Thu, 24 Apr 2008) $"[6:18].strip()

### setup.py ###
from distutils.core import setup
import glob

import os,os.path
def getdirs(path):
    dirs = []
    for file in os.listdir(path ):
        if os.path.isdir(os.path.join(path,file)): dirs.append(os.path.join(path,file))
    return dirs
 
def getfiles(path):
    files = []
    for file in os.listdir(path ):
         if os.path.isfile(os.path.join(path,file)): files.append(os.path.join(path,file))
    return files

def makedata(path):    
    dirs =  [path,]+getdirs(path)
    dirs2 = []
    for n in dirs:
        dirs2 = dirs2+getdirs(n)
    dirs = dirs+dirs2
    res = []
    for n in dirs:
        fs = getfiles(n)
        if len(fs):
            res.append((n,fs))
    return res
    
import bin.HSOconsole
HSCversion = "%s-%spy2.5"%(bin.HSOconsole.__version__,bin.HSOconsole.__date__)
HSCversion = HSCversion.replace('-','_')
f = open("/tmp/HSOconnect.ver",'w')
f.write(HSCversion)
f.close()
df = makedata(r'/usr/share/HSOconnect/configuration')
#df = df +[(r'/etc/acpi/suspend.d',[r'/etc/acpi/suspend.d/20-hsoc.sh',]),] #Platform 

setup (name='HSOconnect',
      version=HSCversion,
      description='A PyGTK connection manager for Option HSDPA and HSUPA data devices',
      author='Paul Hardwick',
      author_email='paul@peck.org.uk',
      url='http://www.pharscape.org',
      license='GPL',
      packages=['hsoc','hsoc.bin','hsoc.bin.serial'],
      package_dir={'hsoc': '.'},
      data_files=df

)
